package edu.tum.motras.algorithms;

import java.util.Iterator;
import java.util.Set;

public abstract class FixedPointAlgorithm<T> {

	protected Set<T> relation;

	protected abstract boolean check(T element);

	final protected void run(Set<T> relation) {
		this.relation = relation;

		boolean modified = true;

		while (modified) {
			modified = false;

			Iterator<T> iterator = this.relation.iterator();

			while (iterator.hasNext()) {
				T element = iterator.next();

				if (!check(element)) {
					iterator.remove();
					modified = true;
				}
			}
		}

		this.relation = null;
	}
}