package edu.tum.motras.algorithms.util;

import java.util.HashMap;
import java.util.Map;

import edu.tum.xmts.TransitionSystem;

public abstract class AbstractMapper<K, V> {

	protected final TransitionSystem system;
	protected final Map<K, V> map;

	public AbstractMapper(TransitionSystem transitionSystem) {
		this.system = transitionSystem;
		this.map = new HashMap<>();
	}

	public V map(K key) {
		if (map.containsKey(key)) {
			return map.get(key);
		}

		V value = create(key);
		map.put(key, value);
		return value;
	}

	protected abstract V create(K key);
}