package edu.tum.motras.algorithms.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import edu.tum.xmts.State;
import edu.tum.xmts.TransitionSystem;

public class StateMapper<K> extends AbstractMapper<K, State> {

	public StateMapper(TransitionSystem transitionSystem) {
		super(transitionSystem);
	}

	@Override
	protected State create(K key) {
		State state;

		if (key instanceof StateSet) {
			List<String> ids = new ArrayList<>();

			for (State keyState : ((StateSet) key).getStates()) {
				ids.add(keyState.getId());
			}

			Collections.sort(ids);
			StringBuilder sb = new StringBuilder();

			Iterator<String> iter = ids.iterator();

			while (iter.hasNext()) {
				sb.append(iter.next());

				if (iter.hasNext()) {
					sb.append("_");
				}
			}

			state = system.states.create(sb.toString());
		} else {
			state = system.states.create();
			state.setLabel(key.toString());
		}

		return state;
	}
}
