package edu.tum.xmts.utils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

public class RandomUtil {
	public static <T> T randomElement(Random random, List<T> list) {
		int index = random.nextInt(list.size());
		return list.get(index);
	}

	public static <T> T randomElement(Random random, Collection<T> collection) {
		int index = random.nextInt(collection.size());
		Iterator<T> iter = collection.iterator();

		for (; index > 0; index--) {
			iter.next();
		}

		return iter.next();
	}

	public static <T> List<T> randomSubList(Random random, Collection<T> collection, int maxElements) {
		ArrayList<T> list = new ArrayList<>(collection);
		Collections.shuffle(list, random);

		if (list.size() <= maxElements) {
			return list;
		}

		return list.subList(0, maxElements);
	}
}